Bug 89436 - FILESAVE: very slow ScHorizontalAttrIterator in XLS(X) saving
Summary: FILESAVE: very slow ScHorizontalAttrIterator in XLS(X) saving
Status: RESOLVED FIXED
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: Calc (show other bugs)
Version:
(earliest affected)
4.2.5.2 release
Hardware: Other All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard: target:4.5.0 target:4.4.2
Keywords:
Depends on:
Blocks:
 
Reported: 2015-02-17 15:42 UTC by László Németh
Modified: 2015-02-28 01:00 UTC (History)
0 users

See Also:
Crash report or crash signature:


Attachments
kcachegrind screenshot - base profile (192.87 KB, image/png)
2015-02-17 17:44 UTC, László Németh
Details
kcachegrind profile - optimized XLS(X) export (204.47 KB, image/png)
2015-02-17 18:10 UTC, László Németh
Details

Note You need to log in before you can comment on or make changes to this bug.
Description László Németh 2015-02-17 15:42:42 UTC
Spreadsheets – especially with more columns – spend a lot of time to use the ScHorizontalAttrIterator.
Comment 1 László Németh 2015-02-17 17:44:45 UTC
Created attachment 113469 [details]
kcachegrind screenshot - base profile
Comment 2 Adolfo Jayme 2015-02-17 17:51:37 UTC
http://cgit.freedesktop.org/libreoffice/core/commit/?id=a5ab0e3a8b1cb7c06072229e1c4d956eb81fa002

(I’m assuming the role of the Bugzilla notifier :P)
Comment 3 László Németh 2015-02-17 18:10:07 UTC
Created attachment 113472 [details]
kcachegrind profile - optimized XLS(X) export

Profile of exporting an XLSX test file with ~15 data columns. Changes in the estimated cycle numbers: 21.2b -> 19.8b (6.5% speed up by removing ~1.4b cycles of ScHorizontalAttrIterator::GetNext().)
Comment 4 László Németh 2015-02-17 23:39:36 UTC
(In reply to Adolfo Jayme from comment #2)
> http://cgit.freedesktop.org/libreoffice/core/commit/
> ?id=a5ab0e3a8b1cb7c06072229e1c4d956eb81fa002
> 

Also the first part: http://cgit.freedesktop.org/libreoffice/core/commit/?id=4de4f1fd1125bc8cf6059cf143bb76d1ab212434

> (I’m assuming the role of the Bugzilla notifier :P)

(Hi Adolfo, thanks for that! :)
Comment 5 Commit Notification 2015-02-18 23:14:35 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8e9540d3d4909c6dd45c9efa294f565d9735a0d9

tdf#89436 ScHorizontalAttrIterator - fix indices

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 6 Commit Notification 2015-02-18 23:16:19 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=a5ab0e3a8b1cb7c06072229e1c4d956eb81fa002

tdf#89436 handle skipping empty rows

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 7 Commit Notification 2015-02-18 23:18:26 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=4de4f1fd1125bc8cf6059cf143bb76d1ab212434

tdf#89436 fix ScHorizontalAttrIterator performance

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 8 Commit Notification 2015-02-18 23:21:00 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=8e9540d3d4909c6dd45c9efa294f565d9735a0d9

tdf#89436 ScHorizontalAttrIterator - fix indices

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 9 Commit Notification 2015-02-19 14:26:16 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=d619d23a1f641fc910723cc32c4d8c8d9a8f3681

tdf#89436 add unit test for ScHorizontalAttrIterator

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 10 Commit Notification 2015-02-21 01:35:44 UTC
László Németh committed a patch related to this issue.
It has been pushed to "libreoffice-4-4":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=4bc49565331c931f0efb3590db76267a5c911053&h=libreoffice-4-4

tdf#89436 fix ScHorizontalAttrIterator performance

It will be available in 4.4.2.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 11 Commit Notification 2015-02-21 10:55:28 UTC
Eike Rathke committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=3f71a35ac72d604519a3c43a1c1cc44b3e04b420

use a slightly more complicated pattern distribution to check, tdf#89436

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.
Comment 12 Commit Notification 2015-02-28 01:00:22 UTC
László Németh committed a patch related to this issue.
It has been pushed to "master":

http://cgit.freedesktop.org/libreoffice/core/commit/?id=3d586d61d6a2b314783203d92fb0c1b62ea0e95e

tdf#89436 ScHorizontalAttrIterator cleanup

It will be available in 4.5.0.

The patch should be included in the daily builds available at
http://dev-builds.libreoffice.org/daily/ in the next 24-48 hours. More
information about daily builds can be found at:
http://wiki.documentfoundation.org/Testing_Daily_Builds
Affected users are encouraged to test the fix and report feedback.